Skip to main content
POST
/
environment
/
{environmentId}
/
container
Create a container
curl --request POST \
  --url https://api.qovery.com/environment/{environmentId}/container \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "<string>",
  "registry_id": "<string>",
  "image_name": "<string>",
  "tag": "<string>",
  "healthchecks": {
    "readiness_probe": {
      "type": {
        "tcp": {
          "port": 123,
          "host": null
        },
        "http": {
          "path": "/",
          "scheme": "HTTP",
          "port": 123
        },
        "exec": {
          "command": [
            "sh",
            "-c",
            "test -f /tmp/healthy"
          ]
        },
        "grpc": {
          "service": null,
          "port": 123
        }
      },
      "initial_delay_seconds": 30,
      "period_seconds": 10,
      "timeout_seconds": 5,
      "success_threshold": 1,
      "failure_threshold": 9
    },
    "liveness_probe": {
      "type": {
        "tcp": {
          "port": 123,
          "host": null
        },
        "http": {
          "path": "/",
          "scheme": "HTTP",
          "port": 123
        },
        "exec": {
          "command": [
            "sh",
            "-c",
            "test -f /tmp/healthy"
          ]
        },
        "grpc": {
          "service": null,
          "port": 123
        }
      },
      "initial_delay_seconds": 30,
      "period_seconds": 10,
      "timeout_seconds": 5,
      "success_threshold": 1,
      "failure_threshold": 9
    }
  },
  "storage": [
    {
      "type": "FAST_SSD",
      "size": 16,
      "mount_point": "/mnt/images",
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
    }
  ],
  "ports": [
    {
      "internal_port": 8080,
      "publicly_accessible": true,
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "name": "<string>",
      "external_port": 8080,
      "is_default": true,
      "protocol": "HTTP",
      "public_path": "<string>",
      "public_path_rewrite": "<string>"
    }
  ],
  "description": "<string>",
  "arguments": [
    "<string>"
  ],
  "entrypoint": "<string>",
  "cpu": 1250,
  "memory": 1024,
  "gpu": 1,
  "min_running_instances": 1,
  "max_running_instances": 1,
  "auto_preview": true,
  "auto_deploy": true,
  "annotations_groups": [
    {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
    }
  ],
  "labels_groups": [
    {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
    }
  ],
  "icon_uri": "<string>"
}
'
{
  "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "created_at": "2023-11-07T05:31:56Z",
  "image_name": "<string>",
  "tag": "<string>",
  "registry": {
    "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "name": "<string>",
    "url": "<string>",
    "kind": "ECR"
  },
  "environment": {
    "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
  },
  "maximum_cpu": 16000,
  "maximum_memory": 16384,
  "maximum_gpu": 2,
  "name": "<string>",
  "cpu": 1250,
  "memory": 1024,
  "gpu": 1,
  "min_running_instances": 1,
  "max_running_instances": 1,
  "healthchecks": {
    "readiness_probe": {
      "type": {
        "tcp": {
          "port": 123,
          "host": null
        },
        "http": {
          "path": "/",
          "scheme": "HTTP",
          "port": 123
        },
        "exec": {
          "command": [
            "sh",
            "-c",
            "test -f /tmp/healthy"
          ]
        },
        "grpc": {
          "service": null,
          "port": 123
        }
      },
      "initial_delay_seconds": 30,
      "period_seconds": 10,
      "timeout_seconds": 5,
      "success_threshold": 1,
      "failure_threshold": 9
    },
    "liveness_probe": {
      "type": {
        "tcp": {
          "port": 123,
          "host": null
        },
        "http": {
          "path": "/",
          "scheme": "HTTP",
          "port": 123
        },
        "exec": {
          "command": [
            "sh",
            "-c",
            "test -f /tmp/healthy"
          ]
        },
        "grpc": {
          "service": null,
          "port": 123
        }
      },
      "initial_delay_seconds": 30,
      "period_seconds": 10,
      "timeout_seconds": 5,
      "success_threshold": 1,
      "failure_threshold": 9
    }
  },
  "auto_preview": true,
  "icon_uri": "<string>",
  "service_type": "APPLICATION",
  "updated_at": "2023-11-07T05:31:56Z",
  "storage": [
    {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "type": "FAST_SSD",
      "size": 16,
      "mount_point": "/mnt/images"
    }
  ],
  "registry_id": "<string>",
  "description": "<string>",
  "arguments": [
    "<string>"
  ],
  "entrypoint": "<string>",
  "ports": [
    {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "internal_port": 8080,
      "publicly_accessible": true,
      "protocol": "HTTP",
      "name": "<string>",
      "external_port": 8080,
      "is_default": true,
      "public_path": "<string>",
      "public_path_rewrite": "<string>"
    }
  ],
  "auto_deploy": true,
  "annotations_groups": [
    {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "created_at": "2023-11-07T05:31:56Z",
      "name": "<string>",
      "annotations": [
        {
          "key": "<string>",
          "value": "<string>"
        }
      ],
      "scopes": [
        "DEPLOYMENTS"
      ],
      "updated_at": "2023-11-07T05:31:56Z"
    }
  ],
  "labels_groups": [
    {
      "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
      "created_at": "2023-11-07T05:31:56Z",
      "name": "<string>",
      "labels": [
        {
          "key": "<string>",
          "value": "<string>",
          "propagate_to_cloud_provider": true
        }
      ],
      "updated_at": "2023-11-07T05:31:56Z"
    }
  ],
  "autoscaling": {
    "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "created_at": "2023-11-07T05:31:56Z",
    "service_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
    "mode": "KEDA",
    "polling_interval_seconds": 123,
    "cooldown_period_seconds": 123,
    "scalers": [
      {
        "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
        "created_at": "2023-11-07T05:31:56Z",
        "scaler_type": "<string>",
        "enabled": true,
        "role": "PRIMARY",
        "updated_at": "2023-11-07T05:31:56Z",
        "config_json": {},
        "config_yaml": "<string>",
        "trigger_authentication": {
          "id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
          "created_at": "2023-11-07T05:31:56Z",
          "organization_id": "<string>",
          "name": "<string>",
          "updated_at": "2023-11-07T05:31:56Z",
          "config_yaml": "<string>"
        }
      }
    ],
    "updated_at": "2023-11-07T05:31:56Z"
  }
}

Documentation Index

Fetch the complete documentation index at: https://qovery-update-mcp-query.mintlify.app/llms.txt

Use this file to discover all available pages before exploring further.

Authorizations

Authorization
string
header
required

JWT tokens should be used with OIDC account (human to machine). JWT tokens used by the Qovery console to communicate with the API have a TTL. Curl Example ' curl https://console.qovery.com/organization -H "Authorization: Bearer $qovery_token" '

Path Parameters

environmentId
string<uuid>
required

Environment ID

Body

application/json
name
string
required

name is case insensitive

registry_id
string
required

id of the linked registry

image_name
string
required

The image name pattern differs according to chosen container registry provider:

  • ECR: repository
  • SCALEWAY_CR: namespace/image
  • DOCKER_HUB: image or repository/image
  • PUBLIC_ECR: registry_alias/repository
tag
string
required

tag of the image container

healthchecks
object
required
storage
object[]
ports
object[]
description
string

give a description to this container

arguments
string[]
entrypoint
string

optional entrypoint when launching container

cpu
integer
default:500

unit is millicores (m). 1000m = 1 cpu

Example:

1250

memory
integer
default:512

unit is MB. 1024 MB = 1GB

Example:

1024

gpu
integer
default:0
Required range: x >= 0
Example:

1

min_running_instances
integer
default:1

Minimum number of instances running. This resource auto-scale based on the CPU and Memory consumption. Note: 0 means that there is no container running.

Required range: x >= 0
max_running_instances
integer
default:1

Maximum number of instances running. This resource auto-scale based on the CPU and Memory consumption. Note: -1 means that there is no limit.

auto_preview
boolean

Indicates if the 'environment preview option' is enabled for this container.
If enabled, a preview environment will be automatically cloned when /preview endpoint is called.
If not specified, it takes the value of the auto_preview property from the associated environment.

auto_deploy
boolean | null

Specify if the container will be automatically updated after receiving a new image tag. The new image tag shall be communicated via the "Auto Deploy container" endpoint https://api-doc.qovery.com/#tag/Containers/operation/autoDeployContainerEnvironments

annotations_groups
object[]
labels_groups
object[]
icon_uri
string<uri>

Icon URI representing the container.

autoscaling
AutoscalingPolicyRequest · object

Response

Create container

id
string<uuid>
required
read-only
created_at
string<date-time>
required
read-only
image_name
string
required

The image name pattern differs according to chosen container registry provider:

  • ECR: repository
  • SCALEWAY_CR: namespace/image
  • DOCKER_HUB: image or repository/image
  • PUBLIC_ECR: registry_alias/repository
tag
string
required

tag of the image container

registry
object
required
environment
object
required
maximum_cpu
integer
required

Maximum cpu that can be allocated to the container based on organization cluster configuration. unit is millicores (m). 1000m = 1 cpu

Example:

16000

maximum_memory
integer
required

Maximum memory that can be allocated to the container based on organization cluster configuration. unit is MB. 1024 MB = 1GB

Example:

16384

maximum_gpu
integer
default:0
required

Maximum memory that can be allocated to the container based on organization cluster configuration. unit is MB. 1024 MB = 1GB

Required range: x >= 0
Example:

2

name
string
required

name is case insensitive

cpu
integer
required

unit is millicores (m). 1000m = 1 cpu

Example:

1250

memory
integer
required

unit is MB. 1024 MB = 1GB

Example:

1024

gpu
integer
default:0
required
Required range: x >= 0
Example:

1

min_running_instances
integer
default:1
required

Minimum number of instances running. This resource auto-scale based on the CPU and Memory consumption. Note: 0 means that there is no container running.

Required range: x >= 0
max_running_instances
integer
default:1
required

Maximum number of instances running. This resource auto-scale based on the CPU and Memory consumption. Note: -1 means that there is no limit.

healthchecks
object
required
auto_preview
boolean
required

Indicates if the 'environment preview option' is enabled for this container.
If enabled, a preview environment will be automatically cloned when /preview endpoint is called.
If not specified, it takes the value of the auto_preview property from the associated environment.

icon_uri
string<uri>
required

Icon URI representing the container.

service_type
enum<string>
required

type of the service (application, database, job, ...)

Available options:
APPLICATION,
DATABASE,
CONTAINER,
JOB,
HELM,
TERRAFORM
updated_at
string<date-time>
read-only
storage
object[]
registry_id
string

tag of the image container

description
string

give a description to this container

arguments
string[]
entrypoint
string

optional entrypoint when launching container

ports
object[]
auto_deploy
boolean

Specify if the container will be automatically updated after receiving a new image tag. The new image tag shall be communicated via the "Auto Deploy container" endpoint https://api-doc.qovery.com/#tag/Containers/operation/autoDeployContainerEnvironments

annotations_groups
object[]
labels_groups
object[]
autoscaling
AutoscalingPolicyResponse · object